local HeadCount = LibStub("AceAddon-3.0"):GetAddon("HeadCount2")
local GetItemInfo = GetItemInfo

local Fields = {
	itemId = 0,
	player = "",
	cost   = 0,
	looted = nil,
	quantity = 0,
	zone = 0,
	source = "",
	note = "",
	name = "",
	color = "",
	link = "",
	rarity = 0,
	level = 0,
	type = 0,
	subtype = 0,
	texture = "",
	icon = "Interface\\Icons\\INV_Misc_QuestionMark",
}

local Loot = HeadCount:NewClassFunctions()

function Loot:ParseLink(link)
	return strmatch(link, "item:(%d+):")
end

function Loot:Init(data)
	if data then
		self.itemId = data["itemId"] or self:ParseLink(data["link"])
		self.player = data["player"]
		self.cost = data["cost"]
		self.looted = data["looted"]
		self.quantity = data["quantity"]
		self.zone = data["zone"]
		self.source = data["source"]
		self.note = data["note"]
		self.name, self.link, self.rarity, self.level, _, self.type, self.subtype, _, _, self.texture, _ = GetItemInfo(self.itemId)
		self.color = select(3,strfind(self.link, "|c(%x+)|Hitem:[-%d:]+|h%[.-%]|h|r"))
		self.icon = select(3,strfind(self.texture, "^.*\\(.*)$")) or "Interface\\Icons\\INV_Misc_QuestionMark"
	end
end
-- Add the Class Definition to Registry
HeadCount:DefineClass("Loot",Fields,Loot)